<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from cookbook.texi on 28 April 1999 -->

<TITLE>The SUIF COOKBOOK - Example 5</TITLE>
<link href="cookbook_7.html" rel=Next>
<link href="cookbook_5.html" rel=Previous>
<link href="cookbook_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="cookbook_1.html">first</A>, <A HREF="cookbook_5.html">previous</A>, <A HREF="cookbook_7.html">next</A>, <A HREF="cookbook_8.html">last</A> section, <A HREF="cookbook_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC26" HREF="cookbook_toc.html#TOC26">Example 5 - Rename Loop Indexes</A></H1>

<P>
This is a real SUIF pass with code modification used in our
experiments.  We wanted a unique and printable identifier for each
loop. The loop index variable was the perfect candidate. But since the
same variable may be used as the index for many loops, we wrote a pass
to update the code and provide a unique variable for all the loop nests.

</P>


<H2><A NAME="SEC27" HREF="cookbook_toc.html#TOC27">rename.h</A></H2>

<PRE>
#define MAXDEPTH        64

class rename {
    static int unum;
    var_sym * from_name[MAXDEPTH];
    var_sym * to_name[MAXDEPTH];
    int dep;
    boolean kill_ind_var;
public: 
    rename()                            { dep = 0; 
                                          kill_ind_var = FALSE; }
    void rename_for(tree_proc * tp);
    void rename_for(tree_node_list * tnl);
    void rename_for(tree_node * tn);
    void rename_for(instruction * ins);
    sym_node * rename_for(sym_node *);
    void begin_for(tree_for * tf);
    void finish_for(tree_for * tf);
    var_sym * find_map(var_sym *);
};
</PRE>



<H2><A NAME="SEC28" HREF="cookbook_toc.html#TOC28">rename.cc</A></H2>

<PRE>
#include &#60;stdlib.h&#62;
#include &#60;suif1.h&#62;
#include &#60;suifmath.h&#62;
#include &#60;builder.h&#62;
#include "rename.h"

int rename::unum = 0;

void rename::rename_for(tree_proc * tp)
{
    block::set_proc(tp);
    kill_ind_var = (tp-&#62;proc()-&#62;src_lang() == src_fortran);
    rename_for(tp-&#62;body());
}

/***************************************************************************
 * Recurse through the control flow structure renaming loop indices        *
 ***************************************************************************/
void rename::rename_for(tree_node_list * tnl)
{
    tree_node_list_iter iter(tnl);
    while(!iter.is_empty()) {
        tree_node * tn = iter.step();
        rename_for(tn);
    }
}

void rename::rename_for(tree_node * tn)
{
    switch(tn-&#62;kind()) {
    case TREE_FOR:
        tree_for * tnf = (tree_for *)tn;
        //printf("For loop %s\n", tnf-&#62;index()-&#62;name());
        rename_for(tnf-&#62;lb_list());
        rename_for(tnf-&#62;ub_list());
        rename_for(tnf-&#62;step_list());
        begin_for(tnf);
        rename_for(tnf-&#62;landing_pad());
        rename_for(tnf-&#62;body());
        finish_for(tnf);
        break;
        
    case TREE_IF:
        tree_if * tni = (tree_if *)tn;
        rename_for(tni-&#62;header());
        rename_for(tni-&#62;then_part());
        rename_for(tni-&#62;else_part());
        break;
        
    case TREE_LOOP:
        tree_loop * tnl = (tree_loop *)tn;
        rename_for(tnl-&#62;body());
        rename_for(tnl-&#62;test());
        break;
        
    case TREE_BLOCK:
        tree_block * tnb = (tree_block *)tn;
        rename_for(tnb-&#62;body());
        break;
        
    case TREE_INSTR:
        tree_instr * tnin = (tree_instr *)tn;
        rename_for(tnin-&#62;instr());
        break;

    default:
        assert(0);
        break;
    }
}

void rename::rename_for(instruction * ins)
{
    for(int i=0; i&#60;ins-&#62;num_srcs(); i++) {
        operand op(ins-&#62;src_op(i));
        if(op.is_instr())
            rename_for(op.instr());
        else if(op.is_symbol()) {
            if(op.symbol()-&#62;is_var()) {
                var_sym * map = find_map((var_sym *)op.symbol());
                if(map) ins-&#62;set_src_op(i, operand(map));
            }
        }
    }
}

/***************************************************************************
 * Starting a for loop, find variable name to rename the index.            *
 ***************************************************************************/
void rename::begin_for(tree_for * tf)
{
    assert(dep &#60; MAXDEPTH);
    from_name[dep] = tf-&#62;index();
    
    tree_proc * tp = tf-&#62;proc()-&#62;block();
    type_node * tn = tf-&#62;index()-&#62;type();
    char name[64];
    sprintf(name, "%s_%d", tf-&#62;index()-&#62;name(), unum++);
    to_name[dep] = (var_sym *)tp-&#62;symtab()-&#62;new_unique_var(tn, name);
    tf-&#62;set_index(to_name[dep]);
    dep++;
}

/***************************************************************************
 * Ending a for loop.  If needed, update the original index to curr. value *
 ***************************************************************************/
void rename::finish_for(tree_for * tf)
{
    if(!kill_ind_var) {
        block bf(from_name[dep-1]);
        block bt(to_name[dep-1]);
        block b(bf = bt);
        tree_node * tn = b.make_tree_node();
        tf-&#62;parent()-&#62;insert_after(tn, tf-&#62;list_e());
    }

    dep--;
    assert(dep &#62;= 0);
}

var_sym * rename::find_map(var_sym *v)
{
    for(int i=0; i&#60;dep; i++)
        if(from_name[i] == v) return to_name[i];
    return NULL;
}

/***************************************************************************
 * process each procedure                                                  *
 ***************************************************************************/
void do_proc(tree_proc * tp)
{
    rename R;
    R.rename_for(tp);
}

/***************************************************************************
 *                                                                         *
 ***************************************************************************/
main(int argc, char * argv[])
{ 
    start_suif(argc, argv);
    suif_proc_iter(argc, argv, do_proc, TRUE, TRUE, TRUE);
}    
</PRE>

<P>
<A NAME="IDX184"></A>
<A NAME="IDX185"></A>
<A NAME="IDX186"></A>
<A NAME="IDX187"></A>
<A NAME="IDX188"></A>
<A NAME="IDX189"></A>
<A NAME="IDX190"></A>
<A NAME="IDX191"></A>
<A NAME="IDX192"></A>
<A NAME="IDX193"></A>
<A NAME="IDX194"></A>
<A NAME="IDX195"></A>
<A NAME="IDX196"></A>
<A NAME="IDX197"></A>
<A NAME="IDX198"></A>
<A NAME="IDX199"></A>
<A NAME="IDX200"></A>
<A NAME="IDX201"></A>
<A NAME="IDX202"></A>
<A NAME="IDX203"></A>
<A NAME="IDX204"></A>
<A NAME="IDX205"></A>
<A NAME="IDX206"></A>
<A NAME="IDX207"></A>
<A NAME="IDX208"></A>
<A NAME="IDX209"></A>
<A NAME="IDX210"></A>
<A NAME="IDX211"></A>
<A NAME="IDX212"></A>
<A NAME="IDX213"></A>
<A NAME="IDX214"></A>
<A NAME="IDX215"></A>
<A NAME="IDX216"></A>
<A NAME="IDX217"></A>
<A NAME="IDX218"></A>
<A NAME="IDX219"></A>
<A NAME="IDX220"></A>
<A NAME="IDX221"></A>
<A NAME="IDX222"></A>
<A NAME="IDX223"></A>
<A NAME="IDX224"></A>
<A NAME="IDX225"></A>
<A NAME="IDX226"></A>
<A NAME="IDX227"></A>
<A NAME="IDX228"></A>
<A NAME="IDX229"></A>
<A NAME="IDX230"></A>
<A NAME="IDX231"></A>
<A NAME="IDX232"></A>
<A NAME="IDX233"></A>
<A NAME="IDX234"></A>
<A NAME="IDX235"></A>
<A NAME="IDX236"></A>
<A NAME="IDX237"></A>
<A NAME="IDX238"></A>
<A NAME="IDX239"></A>
<A NAME="IDX240"></A>
<A NAME="IDX241"></A>
<A NAME="IDX242"></A>
<A NAME="IDX243"></A>
<A NAME="IDX244"></A>
<A NAME="IDX245"></A>

</P>
<P>
<A NAME="IDX246"></A>
<A NAME="IDX247"></A>
<A NAME="IDX248"></A>
<A NAME="IDX249"></A>
<A NAME="IDX250"></A>
<A NAME="IDX251"></A>
<A NAME="IDX252"></A>

</P>



<H2><A NAME="SEC29" HREF="cookbook_toc.html#TOC29">Makefile</A></H2>

<PRE>
TARGET =	rename
LIBS =	-lbuilder -luseful -lsuif1
HEADERS =	rename.h
SRCS =		rename.cc 
OBJS =		rename.o  
all:		rename
install-bin:	install-prog
include $(SUIFHOME)/Makefile.std
</PRE>



<H2><A NAME="SEC30" HREF="cookbook_toc.html#TOC30">Testing the pass</A></H2>
<P>
Let's use the following input file:

</P>


<H3><A NAME="SEC31" HREF="cookbook_toc.html#TOC31">input5.c</A></H3>

<PRE>
main()
{
    int i, j, k;

    for (i=0; i&#60;10; i++)
	for (j=0; j&#60;10; j++)
	    k = k+1;
    
    for (i=10; i&#62;0; i--)
	k = k-1;
}
</PRE>



<H3><A NAME="SEC32" HREF="cookbook_toc.html#TOC32">Test session</A></H3>

<PRE>
csh&#62; scc -V -.spd input5.c
CPP: /suif/suif/suifhome/mips-dec-ultrix/bin/cpp -D__SCC__ -D__LANGUAGE_C -D__unix 
-D__host_mips -D__mips -D__MIPSEL   -I/suif/suif/suifhome/mips-dec-ultrix/include -nostdinc 
-I/usr/include input5.c /tmp/scc22943_0.i
SNOOT: /suif/suif/suifhome/mips-dec-ultrix/bin/snoot   /tmp/scc22943_0.i /tmp/scc22943_1.snt
PORKY_DEFAULTS: /suif/suif/suifhome/mips-dec-ultrix/bin/porky -defaults
/tmp/scc22943_1.snt input5.spd
csh&#62; rename input5.spd input5.out
csh&#62; s2c input5.out
    [...]
extern int main()
  {
    int i;
    int j;
    int k;
    int i_03;
    int j_14;
    int i_25;

    for (i_03 = 0; i_03 &#60; 10; i_03++)
      {
        for (j_14 = 0; j_14 &#60; 10; j_14++)
          {
            k = k + 1;
          }
        j = j_14;
      }
    i = i_03;
    for (i_25 = 10; i_25 &#62; 0; i_25--)
      {
        k = k - 1;
      }
    i = i_25;
    return 0;
  }
csh&#62;
</PRE>

<P><HR><P>
<p>Go to the <A HREF="cookbook_1.html">first</A>, <A HREF="cookbook_5.html">previous</A>, <A HREF="cookbook_7.html">next</A>, <A HREF="cookbook_8.html">last</A> section, <A HREF="cookbook_toc.html">table of contents</A>.
</BODY>
</HTML>
